from sqlalchemy import ForeignKey
from sqlalchemy import CHAR
from sqlalchemy import DATE
from sqlalchemy import VARCHAR
from sqlalchemy import Column
from sqlalchemy import Integer
from sqlalchemy.orm import relationship

from asc.core.database.model import Model
from models.melhorenvio import OrderDelivery


class Order(Model):
    __tablename__ = 'order'
    __table_args__ = {'schema': 'private'}

    id_order = Column(Integer, primary_key=True)
    id_user = Column(Integer, nullable=False)
    id_order_status = Column(Integer, nullable=False, server_default='7')
    id_shipment = Column(Integer, nullable=False)
    id_order_delivery = Column(ForeignKey('private.order_delivery.id_order_delivery', ondelete='CASCADE', onupdate='RESTRICT'))

    order_id_order_delivery_fkey = relationship('OrderDelivery')


class User(Model):
    __tablename__ = 'user'
    __table_args__ = {'schema': 'private'}

    id_user = Column(Integer, primary_key=True)
    name = Column(VARCHAR)
    udoc = Column(VARCHAR)
    utel = Column(VARCHAR)
    mail = Column(VARCHAR)


class UserCard(Model):
    __tablename__ = 'user_card'
    __table_args__ = {'schema': 'private'}

    id_user_card = Column(Integer,primary_key=True)
    id_user = Column(ForeignKey('private.user.id_user'),nullable=False)
    dt_add = Column(DATE,nullable=False)
    dt_exp = Column(CHAR(4),nullable=False)
    nm_holder = Column(VARCHAR,nullable=False)
    nr_card = Column(CHAR(64),nullable=False)
    nr_cvv = Column(CHAR(3),nullable=False)
    id_user_endereco = Column(Integer,nullable=False)

